//
//	aegis - project change supervisor
//	Copyright (C) 1997, 1999, 2002-2008 Peter Miller
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 3 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program. If not, see
//	<http://www.gnu.org/licenses/>.
//
// common/libdir.cc.  Generated from libdir.cc.in by configure.
//

#include <common/ac/stdlib.h>
#include <common/libdir.h>


const char *
configured_prefix(void)
{
    return "/usr/pkg";
}


//
// On a network, may ONLY be shared betwen machines of identical
// cpu-vendor-os flavour.  Probably mounted read-only.
//
// This is where the executable files live.
//

const char *
configured_bindir(void)
{
    return "/usr/pkg/bin";
}


//
// On a network, may ONLY be shared betwen machines of identical
// cpu-vendor-os flavour.  Probably mounted read-only.
//

const char *
configured_libdir(void)
{
    return "/usr/pkg/lib/aegis";
}


//
// This is where the error message (.mo) files are parked.
//

const char *
configured_nlsdir(void)
{
    return "/usr/pkg/share/locale";
}


//
// On a network, may be shared betwen all machines.
// Probably mounted read-only.
//
// This is where the various translations of the user documentation are
// parked, all documents, papers and manual pages, for all languages.
//
// This is where the various shell scripts are parked.
//
// This is where the report scripts are parked.
//

const char *
configured_datadir(void)
{
    //
    // This isn't documented.  This is intentional.
    // It should only be used for testing purposes.
    // DO NOT do it for any of the other configured directories.
    //
    char *datadir = getenv("AEGIS_DATADIR");
    if (datadir && *datadir)
        return datadir;

    return "/usr/pkg/share/aegis";
}


const char *
configured_datarootdir(void)
{
    return "/usr/pkg/share/aegis";
}


//
// On a network, may be shared betwen all machines.
// Probably mounted read-only.
//
// This is where the default-language manual entries are parked.
//

const char *
configured_mandir(void)
{
    return "/usr/pkg/man";
}


//
// On a network, must be shared betwen all machines.
// MUST BE mounted Read-Write.
//
// This is where the lockfile lives.
//
// This is where the global state (project index) file lives.
//
// This is where the user ownership state files live.
//

const char *
configured_comdir(void)
{
    return "/usr/pkg/com/aegis";
}


//
// If you choose to edit the values returned by configured_aegis_uid
// and configured_aegis_gid, you MUST make sure that the corresponding
// entries in Makefile agree exactly.
//

int
configured_aegis_uid(void)
{
    return 3;
}


int
configured_aegis_gid(void)
{
    return 3;
}


const char *
configured_exeext(void)
{
    return "";
}


const char *
configured_sysconfdir(void)
{
    return "/usr/pkg/etc";
}
